#define CONFIGURE_INIT
#include "system.h"
#include "returncode.h"
#include "random.h"
#include <stdio.h>
#include <sched.h>
#include <stdlib.h>
#include <semaphore.h>
#include <errno.h>


#include "monitor.h"



void* task_a(void* arg)
{
 int id=0;
 int j=0;
 while(j<3)
   {
   allocate(id, 2, 1);
   wait(4,0);
   printf("task_a with id=0 is running\n");
   release(id, 2, 1);
   j++;
   }
 pthread_exit(0);
 return 0; 
}


void* task_b(void* arg)
{
 int id=1;
 int j=0;
 while(j<3)
   {
   allocate(id, 1, 2);
   wait(4,0);
   printf("task_b with id=1 is running\n");
   release(id, 1, 2);
   j++;
   }
 pthread_exit(0);
 return 0; 
}


void* task_c(void* arg)
{
 int id=2;
 int j=0;
 while(j<3)
   {
   allocate(id, 2, 2);
   wait(4,0);
   printf("task_c with id=2 is running\n");
   release(id, 2, 2);
   j++;
   }
 pthread_exit(0);
 return 0; 
}





void* POSIX_Init(void *argument)
{

 pthread_t id;
 int status;

 init_monitor();
 seed();

 status=pthread_create(&id,NULL,task_a,NULL);
 if(status<0)
	returncode("pthread_create task_a",status);
 status=pthread_create(&id,NULL,task_b,NULL);
 if(status<0)
	returncode("pthread_create task_b",status);
 status=pthread_create(&id,NULL,task_c,NULL);
 if(status<0)
	returncode("pthread_create task_c",status);
	
 pthread_exit(0);
 return 0; 
}



